
filename = "RpTreeMaker_loader.rb"
printf("***** Loading: %s\n",filename)


require 'Win32API' # for Registry functions


# this trace is in case anyone calls one from outside all classes
def trace(*args)
	begin
		smess = sprintf(*args)
		#puts 'TRACE: ' + smess	# always output argument
		if ($rptreemaker)
			scall = caller[0].to_s # who called the routine
			$rptreemaker.dll_call_do_trace(smess, scall)
			return
		else		
			puts smess	# always output argument
		end#if	
		return
	rescue
		warn "arg ERROR IN trace called from: " + caller(1)[0].to_s
	end	
end

# show error message with trace back
# uses sprintf() formatting
def do_error(*args)
	scall = caller[0].to_s # who called the error routine
	$call = caller
	$scall = scall
	smess = "DO_ERROR";
	begin
		smess = sprintf(*args)
	rescue
		warn "arg ERROR IN do_error called from: " + scall
	end	
	p smess + "\n"
	UI.messagebox (smess + "\n\t(" + scall + ")")
end#def	


# make these send 0 and 1 to dll	
class FalseClass; 	def to_i; 	return(0); 	end end
class TrueClass; 	def to_i; 	return(1); 	end end

class String
	# define our special functions for String
	def Left(ilen)
		return("") if (ilen <= 0)		
		ilen = self.length if (ilen > self.length)
		sret = self.slice( 0, ilen )
		#trace("Left: '%s' ilen: %s sret: '%s'",self, ilen, sret)
		return sret
	end#def Left
	# ilen characters starting at ipos (0 = first)
	# if ilen is not specified, return all characters
	def Mid(ipos, ilen = nil)

		# returns a blank string, rather than nil if too large
		return("") if (ipos >= self.length)
		return("") if (ipos < 0)
		
		ilen = self.length - ipos if (ilen == nil)
		ilen = self.length - ipos if (ipos + ilen > self.length)
		return("") if (ipos <= 0)
	
		sret = sret = self.slice( ipos, ipos + ilen - 1 )
		#trace("Mid: '%s' ipos: %s ilen: %s sret: '%s'",self, ipos, ilen, sret)
		return sret
	end
	def Right(ilen)
		# returns a blank string, rather than nil if too small
		return("") if (ilen < 0)
		ilen = self.length if (ilen > self.length)		
	
		sret = sret = self.slice(self.length-ilen , self.length )
		#trace("Mid: '%s' ilen: %s sret: '%s'",self, ilen, sret)
		return sret
	end#def Right


	# Return the portion of the string up to the first NULL character.  This
	# was added for both speed and convenience.
	def nstrip
		self[ /^[^\0]*/ ]
	end#def
	def Find(str, istart = 0)
		ipos = self.index(str,istart)
		ipos = -1 if ipos == nil
		#trace("'%s' str: '%s' ipos: %s",self,str,ipos)
		return ipos
	end#def
	def ReverseFind(str, iend = nil)
		if (iend)
			ipos = self.rindex(str,iend)
		else
			ipos = self.rindex(str)
		end#if
		ipos = -1 if ipos == nil
		#trace("'%s' str: '%s' ipos: %s",self,str,ipos)
		return ipos
	end#def
	
end#class String

	if (!defined?(HKEY_CURRENT_USER))
		#trace("defining functions")
		HKEY_CURRENT_USER  = 0x80000001 
		HKEY_LOCAL_MACHINE = 0x80000002
		KEY_READ   = 0x20019
		#KEY_WRITE = 0x20006
	end#if

class RpTreeMaker
	
	# display the call stack
	def show_stack(name = "")
		$traceback = sprintf("TRACEBACK: %s\n",name)
		calls = caller(1)
		calls.each do |caller|
			$traceback = $traceback + sprintf("     called by: %s\n",caller)
		end
		puts $traceback
	end


	
	def self::get_reg_functions	
		@@RegCloseKey = Win32API.new('advapi32', 'RegCloseKey', 'L', 'L') if @RegCloseKey == nil
		@@RegOpenKeyEx = Win32API.new('advapi32', 'RegOpenKeyEx', 'LPLLP', 'L')  if @RegOpenKeyEx == nil
		@@RegQueryValueEx = Win32API.new('advapi32', 'RegQueryValueEx', 'LPLPPP',	'L') if @RegQueryValueEx == nil
		#@@RegCreateKeyEx = Win32API.new('advapi32'', 'RegCreateKeyEx', 'LPLLLLPPP'   'L')
	end#def

	def self::get_registry_entry(key, sdefault = "")
		#trace("key: %s",key)
		get_reg_functions

		key.tr!('/','\\')
		sret = sdefault
		# strip of section
		spos = key.Find('\\')
		if (spos < 1)
			do_error("Cannot parse registry key %s - Key must contain a backslash",key)
			return(sdefault)
		end#if

		firstpiece = key.Left(spos)
		mainkey = key.Mid(spos+1)
		
		if (firstpiece == "HKEY_LOCAL_MACHINE")
			root = HKEY_LOCAL_MACHINE
		elsif (firstpiece == "HKEY_CURRENT_USER")
			root = HKEY_CURRENT_USER
		else
			do_error("Registry key must start with HKEY: %s",key)
			return(sdefault)
		end#if
		
		# strip off final key
		spos = mainkey.ReverseFind('\\')
		if (spos < 1)
			do_error("Cannot parse registry key %s - Key must contain a backslash",key)
			return(sdefault)
		end#if

		lastpiece = mainkey.Mid(spos+1)
		mainkey = mainkey.Left(spos)

		phkey = [0].pack('L') # a 4 byte string of 0's go get handle
		
		ret =  @@RegOpenKeyEx.call(root, mainkey, 0, KEY_READ, phkey)
		#trace("ret: %s mainkey: %s",ret,mainkey)
		if (ret != 0)
			printf("key not found: %s\n",key);
			return(sdefault)
		end#if
		
		hkey = phkey.unpack('L').first # convert stron pointer to integer
		# create a buffer for the result
		buf  = 0.chr * 1024
		size = [buf.length].pack('L') # store size of buffer
		ret =  @@RegQueryValueEx.call(hkey, lastpiece, 0, 0, buf, size)
		if (ret != 0)
			printf("location not found: %s\n",key);
			return(sdefault)
		end#if
		
		# if ret == ERROR_MORE_DATA, then we should call again with a larger buffer
		@@RegCloseKey.call(hkey)
		sret = buf.nstrip	# stop at 0 byte
		#trace("sret: %s length: %d key: %s\n",sret,sret.length,key)
		return sret
	end#def
	
	# this returns the location without a slash
	def self::find_application_folder(smodule)
		#skey = sprintf("HKEY_LOCAL_MACHINE\\SOFTWARE\\Render Plus Systems\\%s_location", smodule)
		skey = sprintf("HKEY_LOCAL_MACHINE/SOFTWARE/Render Plus Systems/%s_location", smodule)
		sloc = get_registry_entry(skey)
		#trace("sloc: %s from skey: %s",sloc,skey);
		if (sloc && FileTest.exists?(sloc))
			sloc.tr!('/','\\')
			trace("RETURNING 1 sloc: %s",sloc)
			return(sloc) if sloc != nil
		end#if
		
		# see if it exists in SketchUp/../../
		sfolder = File.expand_path(Sketchup.find_support_file("",".") + '../../../Render Plus Systems/' + smodule)
		#trace("sfolder: %s",sfolder)
		sloc = sfolder
		if (sloc && FileTest.exists?(sloc))
			trace("RETURNING 2 sloc: %s",sloc)
			return(sloc) if sloc != nil
		end#if
		
		# Hard wire to c:\program_files
		sloc = sprintf("c:/Program Files/Render Plus Systems/%s", smodule)
		if (sloc && FileTest.exists?(sloc))
			sloc.tr!('/','\\')
			trace("RETURNING 3 sloc: %s",sloc)
			return(sloc) if sloc != nil
		end#if
		return nil
	end#def


end#class RpTreeMaker







#standard folder for release version
$rptreemaker_release_folder = RpTreeMaker::find_application_folder("RpTreeMaker") # DLL locaation for all versions

printf("$rptreemaker_release_folder: %s\n", $rptreemaker_release_folder)

$rptreemaker_debug_folder = File.expand_path('c:/devc_2005/IRenderBatch') # .rb and appl location for debug version

$rptreemaker_is_debug = false

printf("$rptreemaker_debug_folder: %s\n",$rptreemaker_debug_folder)
require 'LangHandler.rb'

$RpTreeMaker_Strings = LanguageHandler.new("RpTreeMaker")

	
srptreemaker_base_file_debug = $rptreemaker_debug_folder.to_s +  '/ruby/RpTreeMaker_base.rb'
srptreemaker_base_file_release = $rptreemaker_release_folder.to_s +  '/ruby/RpTreeMaker_base.rb'
# ADH - for now, load comm_tree_maker.rb as well
# maybe later if we add more .rb files, we will have a load RpTreeMaker under plugins
srptreemaker_comm_file_debug = $rptreemaker_debug_folder.to_s +  '/ruby/comm_tree_maker.rb'
srptreemaker_comm_file_release = $rptreemaker_release_folder.to_s +  '/ruby/comm_tree_maker.rb'
begin
	if (FileTest.exist?( srptreemaker_base_file_debug))
		printf("Setting up for debug mode\n")
		sbase = srptreemaker_base_file_debug
		load(srptreemaker_comm_file_debug)
		load(srptreemaker_base_file_debug)
		#rptreemaker_base("RpTreeMaker")
	elsif (FileTest.exist?( srptreemaker_base_file_release))
		sbase = srptreemaker_base_file_release
		Sketchup.load(srptreemaker_comm_file_release)
		Sketchup.load(srptreemaker_base_file_release)
		#rptreemaker_base("RpTreeMaker")
	else
		printf("RpTreeMaker_base.rb not found\n")
	end#if
rescue Exception => $emess
	printf("ERROR loading: %s\n\t%s\n\tin: %s\n",sbase,$emess.message,$emess.backtrace[0])
end



	
